searchData={"items":[{"type":"module","doc":"Convenience API to start erldns directly.","title":"erldns","ref":"erldns.html"},{"type":"type","doc":"","title":"erldns.keyset/0","ref":"erldns.html#t:keyset/0"},{"type":"function","doc":"","title":"erldns.start/0","ref":"erldns.html#start/0"},{"type":"type","doc":"","title":"erldns.zone/0","ref":"erldns.html#t:zone/0"},{"type":"module","doc":"Erldns admin API.","title":"erldns_admin","ref":"erldns_admin.html"},{"type":"module","doc":"This application will read from your `sys.config` the following example:\n```erlang\n{erldns, [\n    {admin, [\n        {credentials, {<<\"username\">>, <<\"password\">>}},\n        {port, 8083},\n        {middleware, [my_custom_middleware, another_middleware]}\n    ]}\n]}\n```\nwhere `credentials` is a tuple of `username` and `password` as either strings or binaries,\n`port` is a valid Unix port to listen on, and `middleware` is an optional list of\nmiddleware modules that will be applied to all admin API requests.","title":"Configuration: - erldns_admin","ref":"erldns_admin.html#module-configuration"},{"type":"type","doc":"Configuration parameters, see the module documentation for details.","title":"erldns_admin.config/0","ref":"erldns_admin.html#t:config/0"},{"type":"opaque","doc":"Common state for all handlers","title":"erldns_admin.handler_state/0","ref":"erldns_admin.html#t:handler_state/0"},{"type":"function","doc":"","title":"erldns_admin.maybe_start/0","ref":"erldns_admin.html#maybe_start/0"},{"type":"module","doc":"Provide application-wide configuration access.","title":"erldns_config","ref":"erldns_config.html"},{"type":"function","doc":"","title":"erldns_config.ingress_tcp_request_timeout/0","ref":"erldns_config.html#ingress_tcp_request_timeout/0"},{"type":"function","doc":"","title":"erldns_config.ingress_udp_request_timeout/0","ref":"erldns_config.html#ingress_udp_request_timeout/0"},{"type":"function","doc":"","title":"erldns_config.use_root_hints/0","ref":"erldns_config.html#use_root_hints/0"},{"type":"module","doc":"DNSSEC implementation.","title":"erldns_dnssec","ref":"erldns_dnssec.html"},{"type":"function","doc":"Get signed records from a zone","title":"erldns_dnssec.get_signed_records/1","ref":"erldns_dnssec.html#get_signed_records/1"},{"type":"function","doc":"Get signed records from a zone","title":"erldns_dnssec.get_signed_zone_records/1","ref":"erldns_dnssec.html#get_signed_zone_records/1"},{"type":"function","doc":"Apply DNSSEC records to the given message if the zone is signed and DNSSEC is requested.","title":"erldns_dnssec.handle/4","ref":"erldns_dnssec.html#handle/4"},{"type":"function","doc":"","title":"erldns_dnssec.map_nsec_rr_types/1","ref":"erldns_dnssec.html#map_nsec_rr_types/1"},{"type":"function","doc":"","title":"erldns_dnssec.map_nsec_rr_types/2","ref":"erldns_dnssec.html#map_nsec_rr_types/2"},{"type":"function","doc":"This function will potentially sign the given RR set if the following conditions are true:\n\n- DNSSEC is requested\n- The zone is signed","title":"erldns_dnssec.maybe_sign_rrset/3","ref":"erldns_dnssec.html#maybe_sign_rrset/3"},{"type":"function","doc":"Given a zone and a set of records, return the RRSIG records.","title":"erldns_dnssec.rrsig_for_zone_rrset/2","ref":"erldns_dnssec.html#rrsig_for_zone_rrset/2"},{"type":"module","doc":"EDNS0 implementation.","title":"erldns_edns","ref":"erldns_edns.html"},{"type":"function","doc":"Get a property list of EDNS0 options. Supported options are: * {dnssec, true}","title":"erldns_edns.get_opts/1","ref":"erldns_edns.html#get_opts/1"},{"type":"module","doc":"The module that handles the resolution of a single DNS question.\n\nThe meat of the resolution occurs in erldns_resolver:resolve/3","title":"erldns_handler","ref":"erldns_handler.html"},{"type":"module","doc":"Emits the following telemetry events:\n- `[erldns, handler, handoff]` (span)\n- `[erldns, handler, throttle]`\n- `[erldns, handler, error]`\n- `[erldns, handler, refused]`\n- `[erldns, handler, emtpy]`","title":"Telemetry events - erldns_handler","ref":"erldns_handler.html#module-telemetry-events"},{"type":"function","doc":"Get all registered handlers along with the DNS types they handle and associated versions","title":"erldns_handler.get_versioned_handlers/0","ref":"erldns_handler.html#get_versioned_handlers/0"},{"type":"type","doc":"","title":"erldns_handler.handler/0","ref":"erldns_handler.html#t:handler/0"},{"type":"function","doc":"Register a record handler with the default version of 1","title":"erldns_handler.register_handler/2","ref":"erldns_handler.html#register_handler/2"},{"type":"function","doc":"Register a record handler with version","title":"erldns_handler.register_handler/3","ref":"erldns_handler.html#register_handler/3"},{"type":"function","doc":"Start the handler registry process","title":"erldns_handler.start_link/0","ref":"erldns_handler.html#start_link/0"},{"type":"opaque","doc":"","title":"erldns_handler.state/0","ref":"erldns_handler.html#t:state/0"},{"type":"type","doc":"","title":"erldns_handler.versioned_handler/0","ref":"erldns_handler.html#t:versioned_handler/0"},{"type":"module","doc":"Functions related to TXT record parsing.","title":"erldns_txt","ref":"erldns_txt.html"},{"type":"function","doc":"Parse a string into a collection of bit strings, each no longer than 255 characters.","title":"erldns_txt.parse/1","ref":"erldns_txt.html#parse/1"},{"type":"module","doc":"Implementation of AXFR with IP address whitelisting required.","title":"erldns_axfr","ref":"erldns_axfr.html"},{"type":"module","doc":"AXFR zone transfers are not currently implemented. The current \"implementation\" is just a stub.","title":"AXFR Support - erldns_axfr","ref":"erldns_axfr.html#module-axfr-support"},{"type":"function","doc":"","title":"erldns_axfr.call/2","ref":"erldns_axfr.html#call/2"},{"type":"function","doc":"","title":"erldns_axfr.is_enabled/2","ref":"erldns_axfr.html#is_enabled/2"},{"type":"module","doc":"Raise an event if the given message is empty or refused.\n\nMay emit the following telemetry events:\n- `[erldns, pipeline, refused]`, with measurements `#{count => 1}`\n- `[erldns, pipeline, empty]`, with measurements `#{count => 1}`","title":"erldns_empty_verification","ref":"erldns_empty_verification.html"},{"type":"function","doc":"`c:erldns_pipeline:call/2` callback.","title":"erldns_empty_verification.call/2","ref":"erldns_empty_verification.html#call/2"},{"type":"module","doc":"A basic packet cache that is used to avoid multiple lookups for the\nsame question received within the cache TTL.\n\nIn order to work correctly, it should be added to the packet pipeline twice,\nonce early in the processing pipeline, and once _after_ the resolver.","title":"erldns_packet_cache","ref":"erldns_packet_cache.html"},{"type":"module","doc":"```erlang\n{erldns, [\n    {packet_cache, #{\n        enabled => boolean(), %% defaults to true\n        ttl => non_neg_integer(), %% Seconds, defaults to 30\n    }}\n]}\n```","title":"Configuration - erldns_packet_cache","ref":"erldns_packet_cache.html#module-configuration"},{"type":"module","doc":"- `[erldns, pipeline, cache]` spans as triggered by `m:segmented_cache`.","title":"Telemetry events - erldns_packet_cache","ref":"erldns_packet_cache.html#module-telemetry-events"},{"type":"function","doc":"`c:erldns_pipeline:call/2` callback.","title":"erldns_packet_cache.call/2","ref":"erldns_packet_cache.html#call/2"},{"type":"function","doc":"Clear the cache","title":"erldns_packet_cache.clear/0","ref":"erldns_packet_cache.html#clear/0"},{"type":"function","doc":"`c:erldns_pipeline:prepare/1` callback.","title":"erldns_packet_cache.prepare/1","ref":"erldns_packet_cache.html#prepare/1"},{"type":"behaviour","doc":"The pipeline specification.\n\nIt declares a pipeline of sequential transformations to apply to the\nincoming query until a response is constructed.\n\nThis module is responsible for handling the pipeline of pipes that will be\nexecuted when a DNS message is received. Handlers in this pipeline will be\nexecuted sequentially, accumulating the result of each handler and passing\nit to the next. This designs a pluggable framework where new behaviour can\nbe injected as a new pipe handler in the right order.","title":"erldns_pipeline","ref":"erldns_pipeline.html"},{"type":"behaviour","doc":"The following are enabled by default, see their documentation for details:\n\n- `m:erldns_query_throttle`\n- `m:erldns_packet_cache`\n- `m:erldns_resolver`\n- `m:erldns_empty_verification`","title":"Default pipes - erldns_pipeline","ref":"erldns_pipeline.html#module-default-pipes"},{"type":"behaviour","doc":"There are two kind of pipes: function pipes and module pipes.","title":"Types of pipelines - erldns_pipeline","ref":"erldns_pipeline.html#module-types-of-pipelines"},{"type":"behaviour","doc":"A function pipe is by definition any function that receives a `t:dns:message/0`\nand a set of options and returns a `t:dns:message/0`. Function pipes must have\nthe following type signature:\n\n```erlang\n-type pipe() :: fun((dns:message(), opts()) -> return()\n```","title":"Function pipes - erldns_pipeline","ref":"erldns_pipeline.html#module-function-pipes"},{"type":"behaviour","doc":"The preferred mechanism, a module pipe is an extension of the function pipe.\n\nIt is a module that exports:\n* a `c:prepare/1` function which takes a set of options and initializes it, or disables the pipe.\n* a `c:call/2` function with the signature defined as in the function pipe.\n\nThe API expected by a module pipe is defined as a behaviour by this module.","title":"Module pipes - erldns_pipeline","ref":"erldns_pipeline.html#module-module-pipes"},{"type":"behaviour","doc":"```erlang\n{erldns, [\n    {packet_pipeline, [\n        erldns_query_throttle,\n        erldns_packet_cache,\n        erldns_resolver,\n        erldns_packet_cache,\n        erldns_empty_verification\n    ]},\n]}\n```","title":"Configuration - erldns_pipeline","ref":"erldns_pipeline.html#module-configuration"},{"type":"behaviour","doc":"Here's an example of a function pipe that arbitrarily sets the truncated bit\non a message if the query is directed to the \"example.com\" domain:\n\n```erlang\n-module(erldns_packet_pipe_example_set_truncated).\n-behaviour(erldns_pipeline).\n\n-export([prepare/1, call/2]).\n\n-spec prepare(erldns_pipeline:opts()) -> disabled | erldns_pipeline:opts().\nprepare(Opts) ->\n    case enabled() of\n        false -> disabled;\n        true -> Opts\n    end.\n\n-spec call(dns:message(), erldns_pipeline:opts()) -> erldns_pipeline:return().\ncall(#dns_message{questions = [#dns_query{name = <<\"example.com\">>} | _]} = Msg, _Opts) ->\n    Msg#dns_message{tc = true}.\ncall(Msg, _Opts) ->\n    Msg.\n```","title":"Examples - erldns_pipeline","ref":"erldns_pipeline.html#module-examples"},{"type":"callback","doc":"Trigger the pipeline at run-time.\n\nThis callback can return\n- a possibly new `t:dns:message/0`;\n- a tuple containing a new `t:dns:message/0` and a new set of `t:opts/0`;\n- a tuple `{stop, t:dns:message/0}` tuple to stop the pipeline execution altogether.","title":"erldns_pipeline.call/2","ref":"erldns_pipeline.html#c:call/2"},{"type":"function","doc":"","title":"erldns_pipeline.call/2","ref":"erldns_pipeline.html#call/2"},{"type":"type","doc":"The host that originated the request.","title":"erldns_pipeline.host/0","ref":"erldns_pipeline.html#t:host/0"},{"type":"type","doc":"Options that can be passed and accumulated to the pipeline.","title":"erldns_pipeline.opts/0","ref":"erldns_pipeline.html#t:opts/0"},{"type":"type","doc":"","title":"erldns_pipeline.pipe/0","ref":"erldns_pipeline.html#t:pipe/0"},{"type":"callback","doc":"Initialise the pipe handler, triggering side-effects and preparing any necessary metadata.\n\nThis will be called during the pipeline initialisation phase, which should happen at application\nstartup provided you added the pipeline to your application's supervision tree. This will be called\nonly once during application startup and therefore it is an opportunity to do any necessary\npreparations that can reduce the amount of work at runtime and therefore improve performance.\n\nThis callback can return `disabled`, and then the `c:call/2` callback won't be added to the\npipeline.","title":"erldns_pipeline.prepare/1","ref":"erldns_pipeline.html#c:prepare/1"},{"type":"type","doc":"","title":"erldns_pipeline.return/0","ref":"erldns_pipeline.html#t:return/0"},{"type":"type","doc":"The underlying request transport protocol. All requests come either through UDP or TCP.","title":"erldns_pipeline.transport/0","ref":"erldns_pipeline.html#t:transport/0"},{"type":"module","doc":"Stateful query throttling. Currently only throttles `ANY` queries.\n\nWe should throttle `ANY` queries to discourage use of our authoritative name servers\nfor reflection/amplification attacks.","title":"erldns_query_throttle","ref":"erldns_query_throttle.html"},{"type":"module","doc":"```erlang\n{erldns, [\n    {query_throttle, #{\n        enabled := boolean(), %% defaults to true\n        limit := non_neg_integer(), %% Number of queries to allow, defaults to 1\n        ttl := non_neg_integer(), %% Seconds, defaults to 30\n    }}\n]}\n```","title":"Configuration - erldns_query_throttle","ref":"erldns_query_throttle.html#module-configuration"},{"type":"module","doc":"- `[erldns, pipeline, throttle]` spans with `host` in the metadata\n    as triggered by `m:segmented_cache`.\n- `[erldns, pipeline, throttle]` with `host` in the metadata.","title":"Telemetry events - erldns_query_throttle","ref":"erldns_query_throttle.html#module-telemetry-events"},{"type":"function","doc":"`c:erldns_pipeline:call/2` callback.","title":"erldns_query_throttle.call/2","ref":"erldns_query_throttle.html#call/2"},{"type":"function","doc":"Clear the cache","title":"erldns_query_throttle.clear/0","ref":"erldns_query_throttle.html#clear/0"},{"type":"function","doc":"`c:erldns_pipeline:prepare/1` callback.","title":"erldns_query_throttle.prepare/1","ref":"erldns_query_throttle.html#prepare/1"},{"type":"module","doc":"Resolve a DNS query.\n\nSupports only a single question per request: if a request contains multiple questions,\nonly the first question will be resolved.\n\nEmits the following telemetry events:\n- `[erldns, pipeline, resolver, error]` with `#{rc := dns:rcode/0}` metadata.","title":"erldns_resolver","ref":"erldns_resolver.html"},{"type":"function","doc":"","title":"erldns_resolver.best_match/2","ref":"erldns_resolver.html#best_match/2"},{"type":"function","doc":"","title":"erldns_resolver.best_match_at_node/1","ref":"erldns_resolver.html#best_match_at_node/1"},{"type":"function","doc":"`c:erldns_pipeline:call/2` callback.","title":"erldns_resolver.call/2","ref":"erldns_resolver.html#call/2"},{"type":"function","doc":"","title":"erldns_resolver.resolve/3","ref":"erldns_resolver.html#resolve/3"},{"type":"module","doc":"A cache holding all of the zone data.\n\nSupports only a single question per request: if a request contains multiple questions,\nonly the first question will be resolved.","title":"erldns_zone_cache","ref":"erldns_zone_cache.html"},{"type":"function","doc":"Creates a new table.","title":"erldns_zone_cache.create/1","ref":"erldns_zone_cache.html#create/1"},{"type":"function","doc":"Remove a zone from the cache without waiting for a response.","title":"erldns_zone_cache.delete_zone/1","ref":"erldns_zone_cache.html#delete_zone/1"},{"type":"function","doc":"Remove zone RRSet","title":"erldns_zone_cache.delete_zone_rrset/5","ref":"erldns_zone_cache.html#delete_zone_rrset/5"},{"type":"function","doc":"Find a zone for a given qname.","title":"erldns_zone_cache.find_zone/1","ref":"erldns_zone_cache.html#find_zone/1"},{"type":"function","doc":"Find a zone for a given qname.","title":"erldns_zone_cache.find_zone/2","ref":"erldns_zone_cache.html#find_zone/2"},{"type":"function","doc":"Find the SOA record for the given DNS question or zone.","title":"erldns_zone_cache.get_authority/1","ref":"erldns_zone_cache.html#get_authority/1"},{"type":"function","doc":"Get the list of NS and glue records for the given name.\n\nThis function will always return a list, even if it is empty.","title":"erldns_zone_cache.get_delegations/1","ref":"erldns_zone_cache.html#get_delegations/1"},{"type":"function","doc":"Return the record set for the given dname.","title":"erldns_zone_cache.get_records_by_name/1","ref":"erldns_zone_cache.html#get_records_by_name/1"},{"type":"function","doc":"Get all records for the given type and given name.","title":"erldns_zone_cache.get_records_by_name_and_type/2","ref":"erldns_zone_cache.html#get_records_by_name_and_type/2"},{"type":"function","doc":"Return current sync counter","title":"erldns_zone_cache.get_rrset_sync_counter/3","ref":"erldns_zone_cache.html#get_rrset_sync_counter/3"},{"type":"function","doc":"Get a zone for the specific name.\n\nThis function will not attempt to resolve the dname in any way,\nit will simply look up the name in the underlying data store.","title":"erldns_zone_cache.get_zone/1","ref":"erldns_zone_cache.html#get_zone/1"},{"type":"function","doc":"Get all records for the given zone.","title":"erldns_zone_cache.get_zone_records/1","ref":"erldns_zone_cache.html#get_zone_records/1"},{"type":"function","doc":"Check if the name is in a zone.","title":"erldns_zone_cache.in_zone/1","ref":"erldns_zone_cache.html#in_zone/1"},{"type":"function","doc":"Put a name and its records into the cache, along with a SHA which can be\nused to determine if the zone requires updating.\n\nThis function will build the necessary Zone record before inserting.\n\nThe name of each record must be the fully qualified domain name (including the zone part).\n\nHere's an example:\n\n```erlang\nerldns_zone_cache:put_zone({\n  <<\"example.com\">>, <<\"someDigest\">>, [\n    #dns_rr{\n      name = <<\"example.com\">>,\n      type = ?DNS_TYPE_A,\n      ttl = 3600,\n      data = #dns_rrdata_a{ip = {1,2,3,4}}\n    },\n    #dns_rr{\n      name = <<\"www.example.com\">>,\n      type = ?DNS_TYPE_CNAME,\n      ttl = 3600,\n      data = #dns_rrdata_cname{dname = <<\"example.com\">>}\n    }\n  ]}).\n```","title":"erldns_zone_cache.put_zone/1","ref":"erldns_zone_cache.html#put_zone/1"},{"type":"function","doc":"Put zone RRSet","title":"erldns_zone_cache.put_zone_rrset/4","ref":"erldns_zone_cache.html#put_zone_rrset/4"},{"type":"function","doc":"Check if the record name is in the zone.\n\nWill also return true if a wildcard is present at the node.","title":"erldns_zone_cache.record_name_in_zone/2","ref":"erldns_zone_cache.html#record_name_in_zone/2"},{"type":"function","doc":"Given a zone name, list of records, and a digest, update the zone metadata in cache.","title":"erldns_zone_cache.update_zone_records_and_digest/3","ref":"erldns_zone_cache.html#update_zone_records_and_digest/3"},{"type":"function","doc":"Return a list of tuples with each tuple as a name and the version SHA for the zone.","title":"erldns_zone_cache.zone_names_and_versions/0","ref":"erldns_zone_cache.html#zone_names_and_versions/0"},{"type":"behaviour","doc":"Encoding and decoding of zone data in JSON format.\n\nTo write custom codecs, you need to implement the callbacks exposed by this module,\nand register the codec in the configuration.","title":"erldns_zone_codec","ref":"erldns_zone_codec.html"},{"type":"behaviour","doc":"```erlang\n{erldns, [\n    {zones, #{\n        codecs => [sample_custom_zone_codec]\n    }},\n]}\n```","title":"Configuration - erldns_zone_codec","ref":"erldns_zone_codec.html#module-configuration"},{"type":"behaviour","doc":"```erlang\n-module(sample_custom_zone_codec).\n-behaviour(erldns_zone_codec).\n\n-include_lib(\"dns_erlang/include/dns.hrl\").\n-include_lib(\"erldns/include/erldns.hrl\").\n\n-export([decode/1, encode/1]).\n\n-define(DNS_TYPE_SAMPLE, 40000).\n\ndecode(#{~\"name\" := Name, ~\"type\" := ~\"SAMPLE\", ~\"ttl\" := Ttl, ~\"data\" := Data}) ->\n    #dns_rr{\n        name = Name,\n        type = ?DNS_TYPE_SAMPLE,\n        data = maps:get(~\"dname\", Data),\n        ttl = Ttl\n    };\ndecode(_) ->\n    not_implemented.\n\nencode(#dns_rr{name = Name, type = ?DNS_TYPE_SAMPLE, ttl = Ttl, data = Data}) ->\n    #{\n        ~\"name\" => Name,\n        ~\"type\" => ~\"SAMPLE\",\n        ~\"ttl\" => Ttl,\n        ~\"content\" => erlang:iolist_to_binary(io_lib:format(\"~s\", [Data]))\n    };\nencode(_) ->\n    not_implemented.\n```","title":"Custom codecs - erldns_zone_codec","ref":"erldns_zone_codec.html#module-custom-codecs"},{"type":"function","doc":"","title":"erldns_zone_codec.build_zone/4","ref":"erldns_zone_codec.html#build_zone/4"},{"type":"callback","doc":"","title":"erldns_zone_codec.decode/1","ref":"erldns_zone_codec.html#c:decode/1"},{"type":"function","doc":"Takes a JSON map and turns it into a zone.","title":"erldns_zone_codec.decode/1","ref":"erldns_zone_codec.html#decode/1"},{"type":"type","doc":"","title":"erldns_zone_codec.decoder/0","ref":"erldns_zone_codec.html#t:decoder/0"},{"type":"callback","doc":"","title":"erldns_zone_codec.encode/1","ref":"erldns_zone_codec.html#c:encode/1"},{"type":"function","doc":"Equivalent to  encode(Zone, #{mode => zone_to_json}) .","title":"erldns_zone_codec.encode/1","ref":"erldns_zone_codec.html#encode/1"},{"type":"function","doc":"Takes a zone and turns it into a map.","title":"erldns_zone_codec.encode/2","ref":"erldns_zone_codec.html#encode/2"},{"type":"type","doc":"","title":"erldns_zone_codec.encoder/0","ref":"erldns_zone_codec.html#t:encoder/0"},{"type":"function","doc":"Get the list of registered zone parsers.","title":"erldns_zone_codec.list_codecs/0","ref":"erldns_zone_codec.html#list_codecs/0"},{"type":"function","doc":"Register a custom parser module.","title":"erldns_zone_codec.register_codec/1","ref":"erldns_zone_codec.html#register_codec/1"},{"type":"function","doc":"Register a list of custom parser modules.","title":"erldns_zone_codec.register_codecs/1","ref":"erldns_zone_codec.html#register_codecs/1"},{"type":"module","doc":"Functions for loading zones from local or remote sources.","title":"erldns_zone_loader","ref":"erldns_zone_loader.html"},{"type":"module","doc":"```erlang\n{erldns, [\n    {zones, #{\n        path => \"zones.json\",\n        strict => true\n    }\n]}\n```\nSee the type `t:erldns_zones:config/0` for details.","title":"Configuration - erldns_zone_loader","ref":"erldns_zone_loader.html#module-configuration"},{"type":"function","doc":"Load zones.","title":"erldns_zone_loader.load_zones/0","ref":"erldns_zone_loader.html#load_zones/0"},{"type":"function","doc":"Load zones from a file in strict or loose mode.","title":"erldns_zone_loader.load_zones/1","ref":"erldns_zone_loader.html#load_zones/1"},{"type":"module","doc":"The system responsible for loading and caching zone data.\n\nZones are loaded by default from JSON files in the `priv/zones/` directory.\nThe path is configured in `erldns.config` using the `zones.path` setting.\n\nFor more details about zone file format and configuration, see [`ZONES`](priv/zones/ZONES.md).\n\nFor more details about its subsections, see:\n- `m:erldns_zone_cache`\n- `m:erldns_zone_codec`\n- `m:erldns_zone_loader`","title":"erldns_zones","ref":"erldns_zones.html"},{"type":"module","doc":"```erlang\n{erldns, [\n    {zones, #{\n        path => \"zones.json\",\n        strict => true,\n        codecs => [sample_custom_zone_codec]\n    }},\n]}\n```\n\nSee the type `t:config/0` for details.","title":"Configuration - erldns_zones","ref":"erldns_zones.html#module-configuration"},{"type":"type","doc":"Zone configuration.\n\nPath can be a directory, and `strict` declares whether load failure should crash or be ignored.\nIf a path is configured and `strict` is true, and the path is not resolvable, it will fail.\nSee `m:erldns_zone_loader` for more details.\n\nCodecs are a list of modules that implement the `m:erldns_zone_codec` behaviour.","title":"erldns_zones.config/0","ref":"erldns_zones.html#t:config/0"},{"type":"module","doc":"DNS listeners configuration.\n\nIn order to configure, add to the application environment:\n\n```erlang\n{erldns, [\n    {listeners, [\n        #{name => Name, transport => Protocol, ip => IP, port => Port, parallel_factor => PFactor}\n    ]}\n]}\n```\nSee the type `t:config/0` for details.","title":"erldns_listeners","ref":"erldns_listeners.html"},{"type":"module","doc":"Emits the following telemetry events:\n\n### `[erldns, request, start]`\n- Measurements:\n```erlang\nmonotonic_time := integer()\nrequest_size := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\n```\n\n### `[erldns, request, stop]`\n- Measurements:\n```erlang\nmonotonic_time := integer()\nduration := non_neg_integer()\nresponse_size := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\ndnssec := boolean()\n```\n\n### `[erldns, request, error]`\n- Measurements:\n```erlang\ncount := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\nkind => exit | error | throw\nreason => term()\nstacktrace => [term()]\n```\n\n### `[erldns, request, timeout]`\n- Measurements:\n```erlang\ncount := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\n```","title":"Telemetry events - erldns_listeners","ref":"erldns_listeners.html#module-telemetry-events"},{"type":"type","doc":"Configuration map for a listener.\n\nIt can contain the following keys:\n- `Name` is any desired name in the form of an atom,\n- `IP` is `any`, in which case it will listen on all interfaces,\n    or a valid ip address in tuple or string format. Default is `any`.\n- `Port` is a valid port number. Default is `53`.\n- `Protocol` is either `tcp` or `udp`, or `both`. Default is `both`.","title":"erldns_listeners.config/0","ref":"erldns_listeners.html#t:config/0"},{"type":"function","doc":"Get statistics about all listeners.","title":"erldns_listeners.get_stats/0","ref":"erldns_listeners.html#get_stats/0"},{"type":"type","doc":"Name of the listener, a required parameter.","title":"erldns_listeners.name/0","ref":"erldns_listeners.html#t:name/0"},{"type":"type","doc":"A multiplying factor for parallelisation.\n\nThe number of schedulers is multiplied by this factor when creating worker pools.\nBy default, it is `1`. The number of TCP and UDP acceptors will be of this size,\nwhile the number of UDP workers will be 4x and the maximum number of TCP workers will be 1024x.\nNote that the UDP pool is static, while the TCP pool is dynamic.\nSee `m:wpool` and `m:ranch` respectively for details.","title":"erldns_listeners.parallel_factor/0","ref":"erldns_listeners.html#t:parallel_factor/0"},{"type":"type","doc":"Statistics about each listener.","title":"erldns_listeners.stats/0","ref":"erldns_listeners.html#t:stats/0"},{"type":"type","doc":"TCP or UDP, or both. Default is `both`","title":"erldns_listeners.transport/0","ref":"erldns_listeners.html#t:transport/0"},{"type":"extras","doc":"# Erlang DNS Server\n\nServe DNS authoritative responses... with Erlang.\n\n[![Erlang/OTP Versions](https://img.shields.io/badge/erlang%2Fotp-27%7C28-blue)](https://www.erlang.org)\n[![Build Status](https://github.com/dnsimple/erldns/actions/workflows/ci.yml/badge.svg)](https://github.com/dnsimple/erldns/actions/workflows/ci.yml)\n[![Module Version](https://img.shields.io/hexpm/v/erldns.svg)](https://hex.pm/packages/erldns)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/erldns/)\n[![Hex Downloads](https://img.shields.io/hexpm/dt/erldns.svg)](https://hex.pm/packages/erldns)\n[![Coverage Status](https://coveralls.io/repos/github/dnsimple/erldns/badge.svg?branch=main)](https://coveralls.io/github/dnsimple/erldns?branch=main)\n\nThis application consists of three main subsystems:\n\n- `m:erldns_zones`\nThe system responsible for loading and caching zone data.\n\n- `m:erldns_pipeline`\nThe system responsible for processing incoming DNS queries.\n\n- `m:erldns_listeners`\nThe system responsible for listening for incoming DNS queries. The system is designed to be able to listen on multiple ports and interfaces and supports both UDP and TCP, Unix network stack optimisations, and high parallelism.\n\nThere is also an administrative API for querying the current zone cache and for basic control.\nYou can read more about it at `m:erldns_admin`.","title":"Erlang DNS Server","ref":"readme.html"},{"type":"extras","doc":"[Telemetry](https://hex.pm/packages/telemetry) is used to instrument the code.\n\nAll events are divided in the following namespaces:\n\n- `[erldns, pipeline | _]` are triggered by the `m:erldns_pipeline` subsystem.\n- `[erldns, request | _]` are triggered by the `m:erldns_listeners` subsystem.","title":"Instrumentation - Erlang DNS Server","ref":"readme.html#instrumentation"},{"type":"extras","doc":"You can use this application as a standalone service or embedded into your OTP application. In both\ncases, you'll need to: configure it, and load zones.","title":"Getting started - Erlang DNS Server","ref":"readme.html#getting-started"},{"type":"extras","doc":"Zones are loaded from JSON files in the `priv/zones/` directory. The path is configured in `erldns.config` using the `zones.path` setting. For more details about zone file format and configuration, see [`priv/zones/ZONES`](priv/zones/ZONES.md).","title":"Zones - Erlang DNS Server","ref":"readme.html#zones"},{"type":"extras","doc":"An example configuration file can be found in `erldns.example.config`. For more details, see the\nsubsystems and the admin API documentation.\n\nTo get started, copy it into your own `erldns.config` and modify as needed.","title":"Configuration - Erlang DNS Server","ref":"readme.html#configuration"},{"type":"extras","doc":"To build:\n\n```sh\nmake\n```\n\nTo start fresh:\n\n```sh\nmake fresh\nmake\n```","title":"Building - Erlang DNS Server","ref":"readme.html#building"},{"type":"extras","doc":"","title":"Running - Erlang DNS Server","ref":"readme.html#running"},{"type":"extras","doc":"```sh\novermind start\n```","title":"Launch directly - Erlang DNS Server","ref":"readme.html#launch-directly"},{"type":"extras","doc":"```sh\nrebar3 shell\n```","title":"To get an interactive Erlang REPL - Erlang DNS Server","ref":"readme.html#to-get-an-interactive-erlang-repl"},{"type":"extras","doc":"```sh\nrebar3 release\n_build/default/rel/erldns/bin/erldns foreground\n```","title":"Build a distribution with and run the release - Erlang DNS Server","ref":"readme.html#build-a-distribution-with-and-run-the-release"},{"type":"extras","doc":"Here are some queries to try:\n\n```sh\ndig -p 8053 @127.0.0.1 example.com a\ndig -p 8053 @127.0.0.1 example.com cname\ndig -p 8053 @127.0.0.1 example.com ns\ndig -p 8053 @127.0.0.1 example.com mx\ndig -p 8053 @127.0.0.1 example.com spf\ndig -p 8053 @127.0.0.1 example.com txt\ndig -p 8053 @127.0.0.1 example.com sshfp\ndig -p 8053 @127.0.0.1 example.com soa\ndig -p 8053 @127.0.0.1 example.com naptr\ndig -p 8053 @127.0.0.1 -x 127.0.0.1 ptr\n```","title":"Querying - Erlang DNS Server","ref":"readme.html#querying"},{"type":"extras","doc":"If you want to perform some benchmarks, see [`benchmarking`](./BENCHMARKING.md).","title":"Performance - Erlang DNS Server","ref":"readme.html#performance"},{"type":"extras","doc":"AXFR zone transfers are not currently implemented. The current \"implementation\" is just a stub.","title":"AXFR Support - Erlang DNS Server","ref":"readme.html#axfr-support"},{"type":"extras","doc":"To run automated tests:\n\n```sh\nmake test\n```\n\nThis runs the following:\n\n- [erlfmt](https://hex.pm/packages/erlfmt)\n- [Elvis linter](https://hex.pm/packages/elvis_core)\n- [xref](https://www.erlang.org/doc/apps/tools/xref.html)\n- [dialyzer](https://www.erlang.org/doc/apps/dialyzer/dialyzer.html)\n- [ExDoc](https://hexdocs.pm/ex_doc/readme.html)\n- [EUnit](https://www.erlang.org/doc/apps/eunit/chapter.html)\n- [Common Tests](https://www.erlang.org/doc/apps/common_test/ct.html)\n- [Coverage](https://www.erlang.org/doc/apps/tools/cover.html)","title":"Tests - Erlang DNS Server","ref":"readme.html#tests"},{"type":"extras","doc":"# Zones\n\nerldns reads zone files from this folder, and loads them on start. Zones must be formatted as JSON, and stored in `.json` files.","title":"Zones","ref":"zones.html"},{"type":"extras","doc":"All `.json` files within this folder are default zones, packaged with the default `erldns` distribution. They are used to bootstrap the state when you start the project.","title":"Default zones - Zones","ref":"zones.html#default-zones"},{"type":"extras","doc":"You can place your custom zones files inside the `priv/zones/local` directory. The content of this folder is not tracked by version control, and you can use it freely to add more zones for any purpose.","title":"Custom zones - Zones","ref":"zones.html#custom-zones"},{"type":"extras","doc":"A JSON zone file contains an array of 1 or more zones. Each zone has a name and an array of records. Each record has a name, type, ttl and data field. The data field contains a JSON object with one or more attributes that are appropriate for the specific record type.","title":"JSON files - Zones","ref":"zones.html#json-files"},{"type":"extras","doc":"The follow is an example of a collection of zones with a single zone in the collection:\n\n```json\n[\n  {\n    \"name\": \"example.com\",\n    \"records\": [\n      {\n        \"name\": \"example.com\",\n        \"type\": \"SOA\",\n        \"ttl\": 3600,\n        \"data\": {\n          \"mname\": \"ns1.example.com\",\n          \"rname\": \"admin.example.com\",\n          \"serial\": 1234567,\n          \"refresh\": 1,\n          \"retry\": 1,\n          \"expire\": 1,\n          \"minimum\": 1\n        }\n      },\n      {\n        \"name\": \"example.com\",\n        \"type\": \"A\",\n        \"ttl\": 3600,\n        \"data\": {\n          \"ip\": \"1.2.3.4\"\n        }\n      },\n      {\n        \"name\": \"example.com\",\n        \"type\": \"MX\",\n        \"ttl\": 3600,\n        \"data\": {\n          \"preference\": 10,\n          \"exchange\": \"mail.example.com\"\n        }\n      }\n    ]\n  }\n]\n```","title":"Example - Zones","ref":"zones.html#example"},{"type":"extras","doc":"# Contributing to erldns","title":"Contributing to erldns","ref":"contributing.html"},{"type":"extras","doc":"","title":"Getting started - Contributing to erldns","ref":"contributing.html#getting-started"},{"type":"extras","doc":"Clone the repository and move into it:\n\n```shell\ngit clone git@github.com:dnsimple/erldns.git\ncd erldns\n```","title":"1. Clone the repository - Contributing to erldns","ref":"contributing.html#1-clone-the-repository"},{"type":"extras","doc":"","title":"2. Install Erlang - Contributing to erldns","ref":"contributing.html#2-install-erlang"},{"type":"extras","doc":"```shell\nmake\n```\n\n#### Updating Dependencies\n\nWhen dependencies are updated the rebar.lock file will need to be updated for the new dependency to be used. The following command does this:\n\n```shell\nrebar3 upgrade --all\n```","title":"3. Install the dependencies - Contributing to erldns","ref":"contributing.html#3-install-the-dependencies"},{"type":"extras","doc":"If your editor doesn't automatically format Erlang code using [erlfmt](https://github.com/WhatsApp/erlfmt), run:\n\n```shell\nmake format\n```\n\nYou should run this command before releasing.","title":"Formatting - Contributing to erldns","ref":"contributing.html#formatting"},{"type":"extras","doc":"Compile the project and [run the test suite](#testing) to check everything works as expected.","title":"3. Build and test - Contributing to erldns","ref":"contributing.html#3-build-and-test"},{"type":"extras","doc":"```shell\nmake test\n```","title":"Testing - Contributing to erldns","ref":"contributing.html#testing"},{"type":"extras","doc":"The following instructions uses `$VERSION` as a placeholder, where `$VERSION` is a `MAJOR.MINOR.BUGFIX` release such as `1.2.0`.\n\n1. Run the test suite and ensure all the tests pass.\n\n1. Finalize the `","title":"Releasing - Contributing to erldns","ref":"contributing.html#releasing"},{"type":"extras","doc":"1. Commit and push the changes\n\n    ```shell\n    git commit -a -m \"Release $VERSION\"\n    git push origin main\n    ```\n\n1. Wait for CI to complete.\n\n1. Create a signed tag.\n\n    ```shell\n    git tag -a v$VERSION -s -m \"Release $VERSION\"\n    git push origin --tags\n    ```\n\n1. GitHub actions will take it from there and release to","title":"mainsection inCHANGELOG.md` assigning the version. - Contributing to erldns","ref":"contributing.html#mainsection-inchangelog-md-assigning-the-version"},{"type":"extras","doc":"Submit unit tests for your changes. You can test your changes on your machine by [running the test suite](#testing).\n\nWhen you submit a PR, tests will also be run on the [continuous integration environment via GitHub Actions](https://github.com/dnsimple/erldns/actions/workflows/ci.yml).","title":"Tests - Contributing to erldns","ref":"contributing.html#tests"},{"type":"extras","doc":"# Benchmarking\n\nThis guide contains some information on how to benchmark `erldns` locally.","title":"Benchmarking","ref":"benchmarking.html"},{"type":"extras","doc":"The recommended benchmarking tool is [`dnsperf`](https://github.com/DNS-OARC/dnsperf). You can compile it from source or, if on macOS, install it with:\n\n```shell\nbrew install dnsperf\n```","title":"Install dnsperf - Benchmarking","ref":"benchmarking.html#install-dnsperf"},{"type":"extras","doc":"`dnsperf` requires DNS queries to run in order to perform benchmarks. You can use whatever queries to test different aspects of `erldns`, such as how it behaves when mostly responding to unknown records or when you execute the same query many times in a row.\n\nA good start is a small file with some `example.com`-related queries, as `example.com` domains are the default in [the sample config file](./erldns.example.config).\n\nPut this in `queries.txt`:\n\n```text\nthumbs2.ebaystatic.com. AAAA\nsip.hotmail.com. A\ngoogle.com. A\ncache.defamer.com. A\nexample.com. A\nwww.example.com. CNAME\n```","title":"Create a Queries File - Benchmarking","ref":"benchmarking.html#create-a-queries-file"},{"type":"extras","doc":">","title":"Start the Server - Benchmarking","ref":"benchmarking.html#start-the-server"},{"type":"extras","doc":">\n> Start `erldns` as a release to make sure it gets compiled with production-like settings, rather than dev settings (as in `rebar3 shell`).\n\nFirst, create a release:\n\n```shell\nrebar3 release\n```\n\nThen, start the release in the foreground:\n\n```shell\n./_build/default/rel/erldns/bin/erldns foreground\n```","title":"Important - Benchmarking","ref":"benchmarking.html#important"},{"type":"extras","doc":"Now you're ready to run benchmarks. For example:\n\n```shell\ndnsperf -p 8053 -d ./queries.txt -T 4 -c 20 -n 10000\n```\n\nSee `dnsperf -h` for an explanation of the flags.","title":"Run the Benchmark - Benchmarking","ref":"benchmarking.html#run-the-benchmark"},{"type":"extras","doc":"The latest benchmark was run on 2025/06/06 by @nelsonvides, on an 2023 Apple MacBook Pro, 16-inch, M3 Pro CPU, 36GB of memory.\n\nIn these conditions, `erldns` can serve around 85k QPS, in a mix of resolvable and\nnon-authoritative cases; and around 71k QPS when all queries are resolvable\nThe details of the benchmark are below.","title":"Latest Benchmark - Benchmarking","ref":"benchmarking.html#latest-benchmark"},{"type":"extras","doc":"With this query file:\n\n```text\nthumbs2.ebaystatic.com. AAAA\nsip.hotmail.com. A\ngoogle.com. A\ncache.defamer.com. A\nexample.com. A\nwww.example.com. CNAME\n```\n\nThe results are as follows:\n\n```text\nDNS Performance Testing Tool\nVersion 2.14.0\n\n[Status] Command line: dnsperf -p 8053 -d ./queries.txt -T 6 -c 256 -l 30\n[Status] Sending queries (to 127.0.0.1:8053)\n[Status] Started at: Fri Jun  6 20:49:49 2025\n[Status] Stopping after 30.000000 seconds\n[Status] Testing complete (time limit)\n\nStatistics:\n\n  Queries sent:         2558497\n  Queries completed:    2558497 (100.00%)\n  Queries lost:         0 (0.00%)\n\n  Response codes:       NOERROR 852832 (33.33%), REFUSED 1705665 (66.67%)\n  Average packet size:  request 33, response 43\n  Run time (s):         30.000527\n  Queries per second:   85281.735218\n\n  Average Latency (s):  0.000934 (min 0.000039, max 0.022900)\n  Latency StdDev (s):   0.000513\n```\n\n\n#### All resolvable\n\nWith this query file:\n\n```text\nexample.com A\nexample.com NS\nexample.com AAAA\nexample.com CAA\nexample.com CNAME\nldap.example.com A\nns2.test.com A\nwww.test.com CNAME\n```\n\nThe results are as follows:\n\n```text\nDNS Performance Testing Tool\nVersion 2.14.0\n\n[Status] Command line: dnsperf -p 8053 -d ./queries.txt -T 6 -c 256 -l 30\n[Status] Sending queries (to 127.0.0.1:8053)\n[Status] Started at: Fri Jun  6 20:47:56 2025\n[Status] Stopping after 30.000000 seconds\n[Status] Testing complete (time limit)\n\nStatistics:\n\n  Queries sent:         2143197\n  Queries completed:    2143197 (100.00%)\n  Queries lost:         0 (0.00%)\n\n  Response codes:       NOERROR 1875298 (87.50%), NXDOMAIN 267899 (12.50%)\n  Average packet size:  request 29, response 74\n  Run time (s):         30.001319\n  Queries per second:   71436.759164\n\n  Average Latency (s):  0.001183 (min 0.000035, max 0.057426)\n  Latency StdDev (s):   0.001117\n```","title":"A mix of resolvable and non-authoritative - Benchmarking","ref":"benchmarking.html#a-mix-of-resolvable-and-non-authoritative"},{"type":"extras","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"","title":"main - Changelog","ref":"changelog.html#main"},{"type":"extras","doc":"- Rework zones loader [#230](https://github.com/dnsimple/erldns/pull/230)\n- Rework zones codecs [#231](https://github.com/dnsimple/erldns/pull/231)\n- Rework zones cache [#232](https://github.com/dnsimple/erldns/pull/232)\n- Rework documentation and internals [#233](https://github.com/dnsimple/erldns/pull/233)\n- Fix (C)DNS/(C)DNSKEY signing [#235](https://github.com/dnsimple/erldns/pull/235)","title":"7.0.0-rc5 - Changelog","ref":"changelog.html#7-0-0-rc5"},{"type":"extras","doc":"- Fix DNSSEC timestamps [#234](https://github.com/dnsimple/erldns/pull/234)","title":"7.0.0-rc4 - Changelog","ref":"changelog.html#7-0-0-rc4"},{"type":"extras","doc":"- Add statistic functionality to listeners [#227](https://github.com/dnsimple/erldns/pull/227)","title":"7.0.0-rc3 - Changelog","ref":"changelog.html#7-0-0-rc3"},{"type":"extras","doc":"- Refactor the query processing pipeline [#224](https://github.com/dnsimple/erldns/pull/224)\n- Reimplement the network stack [#225](https://github.com/dnsimple/erldns/pull/225)","title":"7.0.0-rc2 - Changelog","ref":"changelog.html#7-0-0-rc2"},{"type":"extras","doc":"- Upgrade `dns_erlang` to v4.\n- Use `segmented_cache` for the zone cache and the throttle modules.","title":"7.0.0-rc1 - Changelog","ref":"changelog.html#7-0-0-rc1"},{"type":"extras","doc":"- Add mailbox length telemetry events.\n- Keep the handlers state in an ets table and avoid the singleton gen_server call.","title":"6.0.2 - Changelog","ref":"changelog.html#6-0-2"},{"type":"extras","doc":"- Add terminating context to telemetry span events","title":"6.0.1 - Changelog","ref":"changelog.html#6-0-1"},{"type":"extras","doc":"- Instrument code using telemetry in a metrics agnostic way.","title":"6.0.0 - Changelog","ref":"changelog.html#6-0-0"},{"type":"extras","doc":"- Introduce support for Logger\n- Remove lager\n- Remove the `erldns_events` singleton.","title":"5.0.0 - Changelog","ref":"changelog.html#5-0-0"},{"type":"extras","doc":"- Export dnssec internal new API endpoint","title":"4.3.1 - Changelog","ref":"changelog.html#4-3-1"},{"type":"extras","doc":"- Add support for NSEC compact denial of existence","title":"4.3.0 - Changelog","ref":"changelog.html#4-3-0"},{"type":"extras","doc":"- Add support for zone records directory loading\n- Add the latest `dnstest` version fixing almost all tests","title":"4.2.4 - Changelog","ref":"changelog.html#4-2-4"},{"type":"extras","doc":"- Update `dns_erlang`: fix EDNS0 compliance for truncated records and unsupported versions","title":"4.2.3 - Changelog","ref":"changelog.html#4-2-3"},{"type":"extras","doc":"- Test admin API and fix bugs related to authentication and json encoding","title":"4.2.2 - Changelog","ref":"changelog.html#4-2-2"},{"type":"extras","doc":"- Ensure supervision tree starts correctly","title":"4.2.1 - Changelog","ref":"changelog.html#4-2-1"},{"type":"extras","doc":"- Merge admin and metrics APIs into this repository.","title":"4.2.0 - Changelog","ref":"changelog.html#4-2-0"},{"type":"extras","doc":"- Hide SPF/TXT multipart handling behind a feature flag\n- Fix a bug mixing SPF and TXT records","title":"4.1.2 - Changelog","ref":"changelog.html#4-1-2"},{"type":"extras","doc":"- Bugfix handling null in the zone parser json payloads","title":"4.1.1 - Changelog","ref":"changelog.html#4-1-1"},{"type":"extras","doc":"- Introduce SPF/TXT multipart handling (#150)","title":"4.1.0 - Changelog","ref":"changelog.html#4-1-0"},{"type":"extras","doc":"- Add ex_doc support\n- Remove support for OpenTelemetry.","title":"4.0.0 - Changelog","ref":"changelog.html#4-0-0"},{"type":"extras","doc":"","title":"3.0.0 - Changelog","ref":"changelog.html#3-0-0"},{"type":"extras","doc":"- Bumps to OTP/27\n- Replaced \"jsx\" with \"json\"\n- Bumps to [dns_erlang/v2.0.0](https://hex.pm/packages/dns_erlang/2.0.0)","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- erlfmt\n- CONTRIBUTING.md\n- CHANGELOG.md\n- release process to hex.pm","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- ...","title":"2.2.0 - Changelog","ref":"changelog.html#2-2-0"},{"type":"extras","doc":"# Copyright (c) 2012-2025 DNSimple Corporation\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","title":"Copyright (c) 2012-2025 DNSimple Corporation","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}